#include <bits/stdc++.h>
#define int long long

using namespace std;

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n; cin >> n;

    vector<int> a(n);
    vector<pair<int, int>> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        p[i] = {i, i};
    }

    for (int t = 1; t < n; ++t) {
        int k; cin >> k;

        int cur = 1, i = 0;
        while (cur <= k) {
            ++cur;
            i = p[i].second + 1;
        }

        vector<int> c;
        int l = p[i - 1].first, r = p[i].second, m = p[i - 1].second;

        for (int j = l; j <= m; ++j) {
            c.push_back(a[j]);
            p[j] = {l, r};
        }

        for (int j = m + 1; j <= r; ++j) {
            c.push_back(a[j]);
            p[j] = {l, r};
        }

        vector<int> pref_mx(c.size()), suf_mx(c.size());

        pref_mx[0] = c[0];
        suf_mx[r - l] = c[r - l];

        for (int j = 1; j <= r - l; ++j) {
            pref_mx[j] = max(pref_mx[j - 1], c[j]);
        }

        for (int j = r - l - 1; j >= 0; --j) {
            suf_mx[j] = max(suf_mx[j + 1], c[j]);
        }

        int ans = 0;

        for (int j = 0; j < c.size(); ++j) {
            ans += min(pref_mx[j], suf_mx[j]) - c[j];
        }

        cout << ans << "\n";
    }
}