#include <bits/stdc++.h>
#define int long long

using namespace std;

const int MOD = 1e9 + 7;

int ans = 0, n, m;
vector<pair<int, int>> a;
unordered_map<int, vector<int>> mp;
vector<vector<bool>> used;

void rec(int x, int y, int type) {
    used[x][y] = true;

    if (!x && !y && type == 2) {
        bool flag = true;

        for (auto [x1, y1] : a) {
            if (!used[x1][y1]) {
                flag = false;
                break;
            }
        }

        if (flag) ++ans;

        used[x][y] = false;

        return;
    }

    if (x == 0 && y == 0) {
        used[x][y] = false;
    }

    if (x == n - 1 && y == m - 1) {
        type = 2;
    }

    if (type == 1) {
        if (!mp[x].empty() && mp[x].back() > y) {
            if (!used[x][y + 1]) rec(x, y + 1, 1);
        } else {
            if (y && x + 1 < n && !used[x + 1][y]) {
                rec(x + 1, y, 1);
            }
            if (y + 1 < m && !used[x][y + 1]) {
                rec(x, y + 1, 1);
            }
        }
    } else {
        if (!mp[x].empty() && mp[x].front() < y) {
            if (!used[x][y - 1])rec(x, y - 1, 2);
        } else {
            if (x && !used[x - 1][y]) {
                rec(x - 1, y, 2);
            }
            if (y && !used[x][y - 1]) {
                rec(x, y - 1, 2);
            }
        }
    }

    used[x][y] = false;
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int k; cin >> n >> m >> k;

    used.assign(n, vector<bool>(m, false));

    a.resize(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i].first >> a[i].second;
        --a[i].first, --a[i].second;
    }

    sort(a.begin(), a.end());

    for (auto [x, y] : a) {
        mp[x].push_back(y);
    }

    rec(0, 0, 1);

    cout << ans * 2;
}