#include <bits/stdc++.h>
#define int long long

using namespace std;

const int MOD = 1e9 + 7;

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n, m, k; cin >> n >> m >> k;

    set<pair<int, int>> s;
    for (int i = 0; i < k; ++i) {
        int x, y; cin >> x >> y;

        s.insert({x - 1, y - 1});
    }

    vector<vector<vector<vector<int>>>> dp(n + m - 1, vector<vector<vector<int>>>(n, vector<vector<int>>(n, vector<int>(k + 1, 0))));

    if (s.find({0, 0}) == s.end()) {
        dp[0][0][0][0] = 1;
    } else {
        dp[0][0][0][1] = 1;
    }

    for (int i = 1; i < n + m - 1; ++i) {
        for (int r1 = 1; r1 < min(n, i + 1); ++r1) {
            for (int r2 = 0; r2 < r1; ++r2) {
                int d1 = i - r1, d2 = i - r2;

                if (d2 > m - 1) continue;

                for (int cnt = 0; cnt <= k; ++cnt) {
                    int cur = cnt;

                    if (s.find({r1, d1}) != s.end()) {
                        --cur;
                    }

                    if (s.find({r2, d2}) != s.end()) {
                        --cur;
                    }

                    if (cur < 0) continue;

                    if (d1 > 0 && d2 > 0) {
                        dp[i][r1][r2][cnt] += dp[i - 1][r1][r2][cur];
                    }

                    if (d1 > 0 && r2 > 0) {
                        dp[i][r1][r2][cnt] += dp[i - 1][r1][r2 - 1][cur];
                    }

                    if (r1 > 0 && r2 > 0) {
                        dp[i][r1][r2][cnt] += dp[i - 1][r1 - 1][r2 - 1][cur];
                    }

                    if (r1 > 0 && d2 > 0) {
                        dp[i][r1][r2][cnt] += dp[i - 1][r1 - 1][r2][cur];
                    }

                    dp[i][r1][r2][cnt] %= MOD;
                }
            }
        }
    }

    if (s.find({n - 1, m - 1}) != s.end()) {
        --k;
    }

    cout << (dp[n + m - 3][n - 1][n - 2][k] * 2) % MOD;
}