#include <bits/stdc++.h>
#define int long long

using namespace std;

const int MOD = 1e9 + 7;

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n, m, k;
    cin >> n >> m >> k;

    if (!k) {
        --n, --m;

        cout << ((n + m) * (n + m - 1) / 2) % MOD;
        return 0;
    }

    set<pair<int, int> > s;
    for (int i = 0; i < k; ++i) {
        int x, y;
        cin >> x >> y;

        s.insert({x - 1, y - 1});
    }

    vector<vector<vector<pair<int, int> > > > dp(
        n + m - 1, vector<vector<pair<int, int> > >(n, vector<pair<int, int> >(n, {0, 0})));

    if (s.find({0, 0}) == s.end()) {
        dp[0][0][0] = {0, 1};
    } else {
        dp[0][0][0] = {1, 1};
    }

    for (int i = 1; i < n + m - 1; ++i) {
        for (int r1 = 1; r1 < min(n, i + 1); ++r1) {
            for (int r2 = 0; r2 < r1; ++r2) {
                int d1 = i - r1, d2 = i - r2;

                if (d2 > m - 1) continue;

                int cur = 0, cnt_cur = 0, cur_k = 0;

                if (s.find({r1, d1}) != s.end()) {
                    ++cur;
                }

                if (s.find({r2, d2}) != s.end()) {
                    ++cur;
                }

                if (d1 > 0 && d2 > 0) {
                    auto [k1, cnt1] = dp[i - 1][r1][r2];

                    if (k1 > cur_k) {
                        cur_k = k1;
                        cnt_cur = cnt1;
                    } else if (k1 == cur_k) {
                        cnt_cur += cnt1;
                    }
                }

                if (d1 > 0 && r2 > 0) {
                    auto [k1, cnt1] = dp[i - 1][r1][r2 - 1];

                    if (k1 > cur_k) {
                        cur_k = k1;
                        cnt_cur = cnt1;
                    } else if (k1 == cur_k) {
                        cnt_cur += cnt1;
                    }
                }

                if (r1 > 0 && r2 > 0) {
                    auto [k1, cnt1] = dp[i - 1][r1 - 1][r2 - 1];

                    if (k1 > cur_k) {
                        cur_k = k1;
                        cnt_cur = cnt1;
                    } else if (k1 == cur_k) {
                        cnt_cur += cnt1;
                    }
                }

                if (r1 > 0 && d2 > 0) {
                    auto [k1, cnt1] = dp[i - 1][r1 - 1][r2];

                    if (k1 > cur_k) {
                        cur_k = k1;
                        cnt_cur = cnt1;
                    } else if (k1 == cur_k) {
                        cnt_cur += cnt1;
                    }
                }

                dp[i][r1][r2] = {cur_k + cur, cnt_cur % MOD};
            }
        }
    }

    if (s.find({n - 1, m - 1}) != s.end()) {
        --k;
    }

    if (dp[n + m - 3][n - 1][n - 2].first < k) {
        cout << 0;
        return 0;
    }

    cout << (dp[n + m - 3][n - 1][n - 2].second * 2) % MOD;
}