#include <bits/stdc++.h>
#define int long long

using namespace std;

int k;

pair<int, int> f(int mask1, int mask2) {
    int tmp1 = mask1, tmp2 = mask2;

    int ans = 0, cnt = 0;

    tmp2 /= k + 1;
    for (int i = 0; i < k; ++i) {
        int cur = 0;

        if (tmp1 % 2) {
            cur++;
        }

        cur += tmp2 % (k + 1);

        if (cur > k - i) return {-1, -1};

        cnt += cur;

        ans += pow(k + 1, i) * cur;

        tmp1 /= 2;
        tmp2 /= k + 1;
    }

    return {cnt, ans};
}

const int MOD = 1e9 + 7;
signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n; cin >> n >> k;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];

    unordered_map<int, int> mp;
    for (int mask = 0; mask < (1 << k); ++mask) {
        int v = 0, cnt = 0;

        for (int i = 0; i < k; ++i) {
            if ((mask >> i) % 2) {
                ++cnt;
                v += pow(k + 1, i);
            }
        }

        if (cnt == a[0]) {
            mp[v]++;
        }
    }

    for (int t = 1; t < n; ++t) {
        unordered_map<int, int> nmp;

        for (auto [arr, cnt] : mp) {
            for (int mask = 0; mask < (1 << k); ++mask) {
                pair<int, int> temp = f(mask, arr);

                if (temp.first == a[t]) {
                    nmp[temp.second] += cnt;

                    if (nmp[temp.second] >= MOD) {
                        nmp[temp.second] -= MOD;
                    }
                }
            }
        }

        swap(nmp, mp);
    }

    int ans = 0;
    for (auto[mask, cnt] : mp) {
        ans += cnt; ans %= MOD;
    }

    cout << ans;

    return 0;
}